;;;; -*- Mode: Lisp; Package: ASDF; -*-

(in-package :asdf)

(defsystem asn.1
  :description "ASN.1 for Common Lisp"
  :version "2.2"
  :author "Chun Tian (binghe) <binghe.lisp@gmail.com>"
  :depends-on (:ieee-floats ; ASN.1 OPAQUE FLOAT encode/decode
               :trivial-gray-streams
               :usocket)
  :components ((:file "package")
               (:module "runtime"
                :depends-on ("package")
		:components ((:file "constants")
			     (:file "ber" :depends-on ("constants"))
			     (:file "base" :depends-on ("ber"))
			     (:file "object-id" :depends-on ("ber"))
                             (:file "integer" :depends-on ("ber"))
                             (:file "null" :depends-on ("ber"))
                             (:file "sequence" :depends-on ("ber"))
                             (:file "string" :depends-on ("ber"))
                             (:file "ipaddress" :depends-on ("ber"))
                             (:file "counter" :depends-on ("ber"))
                             (:file "gauge" :depends-on ("ber"))
                             (:file "timeticks" :depends-on ("ber"))
                             (:file "opaque" :depends-on ("ber"))
                             #+(and lispworks capi)
                             (:file "mibrowser" :depends-on ("object-id"))))
               #+lispworks
	       (:module "compiler"
                :depends-on ("runtime")
		:components ((:file "reader")
			     (:file "syntax")
			     (:file "parser" :depends-on ("reader" "syntax"))
                             (:file "compiler" :depends-on ("parser"))
                             (:file "interpreter" :depends-on ("compiler"))))))
