(in-package :asn.1)

(defgeneric load-asn.1 (object &key &allow-other-keys))

(defmethod load-asn.1 ((file t) &key to &allow-other-keys)
  (let ((result (load-asn.1 (parse file))))
    (if (pathnamep to)
        nil
      result)))

(defmethod load-asn.1 ((rtl list) &key &allow-other-keys)
  (if (atom rtl)
      rtl
    (load-asn.1-internal (car rtl) rtl)))

(defgeneric load-asn.1-internal (type rtl))

(defmethod load-asn.1-internal ((type symbol) (rtl list))
  nil)

(defmethod load-asn.1-internal ((type (eql :module)) (rtl list))
  (declare (ignore type))
  (destructuring-bind (module-name ((exports imports) body)) (cdr rtl)
    (declare (ignore module-name exports imports))
    (let ((expressions (mapcar #'compile-asn.1 body)))
      (dolist (e expressions t)
        (eval e)))))
