;;;; -*- Mode: Lisp; Package: ASN.1; -*-

(in-package :asn.1)

(defun test (str)
  (display str))

(defun test-1 ()
  "Case-Sensitivity test"
  (test "Abc Def"))

(defun test-2 ()
  "Comment test"
  (list (test "asd--asdadsda
               asdasfd")
        (test "xxx /*asdkashfksjdf
                 sdfjkshdf*/ --yyy")
        (test "A -- B -- C")))

(defun test-3 ()
  "ASN.1 Number test"
  (list (test "'123'H")
        (test "'010100001'B")
        (test "'777'O")))

(defun test-4 ()
  "::="
  (test "Married ::= BOOLEAN"))

(defun test-5 ()
  "full test"
  (test "Type ::= SEQUENCE { component1 INTEGER,
                    component2 BOOLEAN,
                    ...,
                    [[ component3 REAL ]], -- version 2
                    ... }"))

(defun test-6 ()
  "full test with numbers"
  (test "counter Lottery-number ::= 45
sextuple Lottery-draw ::= { 7, 12, 23, 31, 33, 41 }
pair Coordinates ::= { x 5, y -3 }
choice Afters ::= dessert:\"profiterolles\""))

(defun test-7 ()
  (parse #p"ASN:TEST;RECORD.ASN"))

(defun test-8 ()
  "XML tags"
  (test "<html>
          <head>XXX</head>
          <body/>
         </html>"))

(defun test-9 ()
  "MACRO test"
  (parse #p"ASN:TEST;MACRO.ASN"))

(defun test-10 ()
  "MACRO test"
  (parse #p"ASN:TEST;IMPORTS.ASN"))

(defun test-11 ()
  "Type Assignment"
  (parse #p"ASN:TEST;TYPE.ASN"))

(defun test-12 ()
  "OID Assignment"
  (parse #p"ASN:TEST;OID.ASN"))

(defun test-13 ()
  "tagged-type test"
  (parse #p"ASN:TEST;TAG.ASN"))

(defun test-14 ()
  "SNMPv2-SMI passed"
  (parse #p"MIB:SNMPv2-SMI"))

(defun test-15 ()
  "SNMPv2-MIB test"
  (parse #p"MIB:SNMPv2-MIB"))

(defun test-16 ()
  "SNMPv2-TC"
  (parse #p"MIB:SNMPv2-TC"))

(defun test-17 ()
  "SNMPv2-TM"
  (parse #p"MIB:SNMPv2-TM"))

(defun test-18 ()
  "SNMPv2-CONF"
  (parse #p"MIB:SNMPv2-CONF"))

(defun test-19 ()
  "SNMP-TARGET-MIB"
  (parse #p"MIB:SNMP-TARGET-MIB"))
