(in-package :asn.1)

#+lispworks
(progn
  (use-package :harlequin-common-lisp)
  (use-package :lispworks))

(export '(oid-length
          oid-name
          oid-name-list
          oid-number-list
          oid-parent
          oid-value))

(defmethod initialize-instance :after ((instance object-id)
                                       &rest initargs &key &allow-other-keys)
  (declare (ignore initargs))
  (if (and (slot-boundp instance 'parent)
           (slot-boundp instance 'value))
      (let ((o (oid-parent instance)))
        (setf (gethash (oid-value instance) (oid-children o)) instance))))

(defun delete-object (oid)
  (declare (type object-id oid))
  (setf (gethash (oid-value oid)
                 (oid-children (oid-parent oid)))
        nil))

(defun oid-parent-p (oid)
  (declare (type object-id oid))
  (slot-boundp oid 'parent))

(export 'oid-parent-p)
